----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:07:38 01/15/2015 
-- Design Name: 
-- Module Name:    minmax - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity minmax is
    Port ( val1 : in  STD_LOGIC_VECTOR (31 downto 0);
           val2 : in  STD_LOGIC_VECTOR (31 downto 0);
           val3 : in  STD_LOGIC_VECTOR (31 downto 0);
           min : out  STD_LOGIC_VECTOR (31 downto 0);
           max : out  STD_LOGIC_VECTOR (31 downto 0));
end minmax;

architecture Behavioral of minmax is

signal sv1, sv2, sv3: signed(31 downto 0);

signal sv12, sv13, sv23: signed(31 downto 0);

signal v12, v13, v23: std_logic_vector(31 downto 0);
signal min1, min2, min3, max1, max2, max3: std_logic;

begin

	sv1 <= signed(val1);
	sv2 <= signed(val2);
	sv3 <= signed(val3);
	
	sv12 <= sv1 - sv2;
	sv13 <= sv1 - sv3;
	sv23 <= sv2 - sv3;
		
	v12 <= std_logic_vector(sv12);
	v13 <= std_logic_vector(sv13);
	v23 <= std_logic_vector(sv23);
	
	min1 <= v12(31) and v13(31);
	min2 <= (not v12(31)) and v23(31);
	min3 <= (not v13(31)) and (not v23(31));
	
	max1 <= (not v12(31)) and ( not v13(31));
	max2 <= (v12(31)) and ( not v23(31));
	max3 <= (v13(31)) and (v23(31));

	process(min1, min2, min3, val1, val2, val3)
	begin
		if min1='1' then
			min <= val1;
		elsif min2='1' then
			min <= val2;
		elsif min3='1' then
			min <= val3;
		else
			min <= (others => '1');
		end if;
	end process;

	process(max1, max2, max3, val1, val2, val3)
	begin
		if max1='1' then
			max <= val1;
		elsif max2='1' then
			max <= val2;
		elsif max3='1' then
			max <= val3;
		else
			max <= (others => '1');
		end if;
	end process;

end Behavioral;

